package pers_test

import (
	"testing"
	"time"

	"git.sr.ht/~nelsam/hel/pkg/pers"
	"git.sr.ht/~nelsam/hel/vegr"
	"git.sr.ht/~nelsam/hel/vegr/ret"
	"github.com/poy/onpar"
	"github.com/poy/onpar/expect"
)

func TestBlockReturn(t *testing.T) {
	o := onpar.BeforeEach(onpar.New(t), func(t *testing.T) expectation {
		return expect.New(t)
	})
	defer o.Run()

	o.Spec("it blocks returns by removing the value from a Blocker field", func(expect expectation) {
		type mock struct {
			FooOutput struct {
				BlockChan ret.Blocker
				Bar       chan bool
			}
		}
		var v mock
		v.FooOutput.BlockChan = vegr.BlockChan()
		v.FooOutput.Bar = make(chan bool, 1)
		unblock := pers.BlockReturns(t, v, "Foo")
		expect(v.FooOutput.BlockChan).To(not(receive(receiveWait(100 * time.Millisecond))))
		unblock()
		expect(v.FooOutput.BlockChan).To(receive())
	})
}
