package mock_test

import (
	"errors"
	"fmt"

	"git.sr.ht/~nelsam/hel/pkg/pers"
	"github.com/poy/onpar/matchers"
)

var (
	equal        = matchers.Equal
	not          = matchers.Not
	haveOccurred = matchers.HaveOccurred
	beNil        = matchers.BeNil
	beTrue       = matchers.BeTrue
	haveLen      = matchers.HaveLen

	haveMethodExecuted = pers.HaveMethodExecuted
	within             = pers.Within
	withArgs           = pers.WithArgs
	returning          = pers.Returning
)

type beErrMatcher struct {
	err error
}

func beErr(err error) *beErrMatcher {
	return &beErrMatcher{err: err}
}

func (m *beErrMatcher) Match(actual any) (any, error) {
	err, ok := actual.(error)
	if !ok {
		return nil, fmt.Errorf("expected type %T to implement error", actual)
	}
	if errors.Is(err, m.err) {
		return err, nil
	}
	return nil, fmt.Errorf("expected error '%v' to wrap error '%v'", err, m.err)
}
